function cirInfo(cirFilename)

% read input data
CIRC_Data = parse(cirFilename);
InOuts    = groupIOs(CIRC_Data);

opTypes = CIRC_Data.opTypes;

nOps  = length(opTypes);
nMuls = 0;
for i = 1:nOps
	nMuls = nMuls + strcmp(opTypes(i,:),'mul');
end
fprintf( 'totally %d operations, of which\n', nOps );
fprintf( '\t%d multiplications, and\n', nMuls );
fprintf( '\t%d ALU operations.\n', nOps - nMuls );

nCoeffs  = length(InOuts.constCoeffs);
nDelays  = length(InOuts.dlydInpsTbl);
fprintf( '%3d constant coefficients\n', nCoeffs );
fprintf( '%3d delay elements\n', nDelays );

nExtInps = length(InOuts.extInps);
fprintf( '%3d input(s) : ', nExtInps );
for i = 1: nExtInps-1
	fprintf( '%s, ', InOuts.extInps{i} );
end
fprintf( '%s\n', InOuts.extInps{nExtInps} );

nExtOutps = length(InOuts.extOutps);
fprintf( '%3d output(s): ', nExtOutps );
for i = 1: nExtOutps-1
	fprintf( '%s, ', InOuts.extOutps{i} );
end
fprintf( '%s\n', InOuts.extOutps{nExtOutps} );

