function gen_VHD_template(cirFilename,SFxd3,toScreen,schedMethod,varargin)
%GEN_VHD_TEMPLATE	Create testbench, wrapper and SSG-template VHDL-files
%	GEN_VHD_TEMPLATE(cirFilename,SFxd3,toScreen,schedMethod,varargin)
%	creates the VHDL files needed for simulation and synthesis.
%	------------------------------------------------------------------------
%	NOTE:	for the lab-sessions, 'NAME_SSG_auto.vhd' IS NOT COMPLETE.
%	------------------------------------------------------------------------
%	'SFxd3' should be a 3-element vector [N M x], in which 'N' indicates the
%	external buswidth (signed fixed point), 'M' the number of bits of 'N' to
%	be used for the fraction part, and 'x' an additional number of bits for
%	extending (the whole-number part of) 'N' inside the SSG (to allow for
%	intermediate results greater or less than can be represented with 
%	'N' bits).
%	If 'toScreen' is 1, the files are written to screen; if 0, they
%	are written to disk. If 'cirFilename' is NAME.cir, they can be found in
%	(a newly created directory) NAME\vhdl. The (top-level) testbench-file
%	will be named 'testbench_NAME_auto.vhd' and for simulation all vhd-files
%	are needed. 
%	Synthesis needs the files 'resources_noV2.vhd', 'NAME_SSG_auto.vhd' and
%	as top level file 'NAME_auto.vhd'.
%	'schedMethod' specifies the scheduling method to be used, and can be
%	'ASAP', 'ALAP', FORCED' or 'LIST'.
%	The parameters that follow 'schedMethod' are dependant on the method
%	choosen, and may be 'delayMUL','delayALU','nMULs' and/or 'nALUs'.
%	-	'delayMUL' and 'delayALU' are the latencies of resp. MULtipliers and 
%		ALUs in integer multiples of a clock cycle. They are optional for 
%		'ASAP' and 'ALAP' (default, if not specified, is 1 cycle each). 
%		At this moment they are not needed for 'forceD' (both fixed to 1).
%		For the 'LIST' method, each of the delays need to be specified.
%	-	'nMULs' and 'nALUs' are the number of available MULtipliers and ALUs,
%		and have to be specified for the 'LIST' method only.
%
% 	examples:	gen_VHD_template('my_file.cir',[16 15 0],1,'asap')
%				gen_VHD_template('my_file.cir',[16 15 2],0,'alap',2,1)
%				gen_VHD_template('my_file.cir',[32 30 4],0,'forceD')
%				gen_VHD_template('my_file.cir,'[24 20 8],0,'list',1,1,3,2)
%
%	NOTE: 	GEN_VHD_TEMPLATE expects to be run from the directory in which 
%			the	.cir-file resides.
% 
%	See also GEN_MTB. 

% (c) H.J. Lincklaen Arriens, 
%     Delft University of Technology, December 2004
%                                     Februari 2005, latencies differing from 1
%                                                    enabled/corrected.
%									  June 2005, << and >> added
