function [MUL2OpTbl,ALU2OpTbl,altMULs,altALUs,op2RscTbl] = mapResources(T,d,iconnTbl,opTypes)
%MAPRESOURCES	For internal use only (registered outputs in resources assumed)
%	[MUL2OpTbl,ALU2OpTbl,altMULs,altALUs,op2RscTbl] =  = MAPRESOURCES(T,d,iconnTbl,opTypes)
 
% (c) H.J. Lincklaen Arriens, 
%     Delft University of Technology
%				June 2005: taken out of gen_VHD and schedGUI because of
%						   new resources with their own output registers
%						   mapMULs, mapALUs: size(nOps,3,nXXXsNeeded)


% this should be corrected 
stillZero      = ( T(:,2) == 0 );
T(stillZero,2) = T(stillZero,1);

nStates     = max( T(:,2) );
nMULsNeeded = max( d(:,1) );
nALUsNeeded = max( d(:,2) );
mapMULs     = zeros(nStates,3,nMULsNeeded);
mapALUs     = zeros(nStates,3,nALUsNeeded);

nOps       = size(iconnTbl,1);
op2RscTbl  = zeros(nOps,2);
% nStates + 1, instead of just nStates, because of wish to print 
% op#a, op#b, etc in case of latencies more than 1 clock cycle
MUL2OpTbl  = zeros(nStates+1,nMULsNeeded);
ALU2OpTbl  = zeros(nStates+1,nALUsNeeded);

% [opNo in1 in2 out]
for i = 1:nStates
	scheduledHere = find( T(:,1) == i );
	for j = 1:length(scheduledHere)
		opNo = scheduledHere(j);
		i2   = T(opNo,2);
		di   = i2 - i +1;
		if strcmp(opTypes(opNo,:),'mul')
			kMUL = find( mapMULs(i,1,:) == 0, 1, 'first' );
			mapMULs(i:i2,:,kMUL) = repmat(iconnTbl(opNo,1:3),di,1);
			op2RscTbl(opNo,1) = kMUL;
			MUL2OpTbl(i:i2,kMUL) = opNo;
		else
			kALU = find( mapALUs(i,1,:) == 0, 1, 'first' );
			mapALUs(i:i2,:,kALU) = repmat(iconnTbl(opNo,1:3),di,1);
			op2RscTbl(opNo,2) = kALU;
			ALU2OpTbl(i:i2,kALU) = opNo;
		end
	end
end


altMULs = zeros( nStates,3,nMULsNeeded);
altALUs = zeros( nStates,3,nALUsNeeded);
for i = 1:nMULsNeeded
	altMULs(:,1:3,i) = lfExtentTimes(mapMULs(:,1:3,i));
end
for i = 1:nALUsNeeded
	altALUs(:,1:3,i) = lfExtentTimes(mapALUs(:,1:3,i));
end


%==========================================================================================
%=========  LOCAL FUNCTIONS  ======  LOCAL FUNCTIONS  ======  LOCAL FUNCTIONS  ============
%==========================================================================================

function altArray = lfExtentTimes(orgArray)
  altArray = orgArray;
  % extent to top
  if ( altArray(1,1) == 0 )	
	firstIx = find( (altArray(:,1) ~= 0),1,'first' );
	if ~isempty(firstIx)
	  altArray(1:firstIx-1,:) = repmat( altArray(firstIx,:), firstIx-1,1 );
	  nextIx  = firstIx +1;
    end
  else
	nextIx = 2;
  end
  % extent downwards
  for i = nextIx:size(orgArray,1)
    if ( altArray(i,1) == 0 )	
	  altArray(i,:) = altArray(i-1,:);
	end
  end

%==========================================================================================
function altArray = lfExtentRegs(orgArray)
  nStates  = size(orgArray,1);
  nRegs    = size(orgArray,2);
  altArray = orgArray;
  for i = 1:nRegs
	isOps = ( find( altArray(:,i) ~= 0 ) );
	% extent to top
	if ( isOps(1) > 1 )
	  altArray(1:isOps(1)-1,i) = altArray(isOps(1),i);
	end
	% extent to bottom
	if ( isOps(end) < nStates )
	  altArray(isOps(end)+1:end,i) = altArray(isOps(end),i);
	end
	% fill gaps if still present (connect to previous one)
	noOps = ( find( altArray(:,i) == 0 ) );
	if ~isempty(noOps)
	  for j = 1:length(noOps)
	  	altArray(noOps(j),i) = altArray(noOps(j)-1,i);
	  end		
	end
  end	 


