function varargout = schedGUI(varargin)
% SCHEDGUI M-file for schedGUI.fig
%      SCHEDGUI, by itself, creates a new SCHEDGUI or raises the existing
%      singleton*.
%
%      H = SCHEDGUI returns the handle to a new SCHEDGUI or the handle to
%      the existing singleton*.
%
%      SCHEDGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SCHEDGUI.M with the given input arguments.
%
%      SCHEDGUI('Property','Value',...) creates a new SCHEDGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before schedGUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to schedGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help schedGUI

% Last Modified by GUIDE v2.5 21-Oct-2005 17:03:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @schedGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @schedGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before schedGUI is made visible.
function schedGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to schedGUI (see VARARGIN)

% Choose default command line output for schedGUI
handles.output = hObject;

% Update handles structure
bfSlash       = filesep;
handles.inDir = [ '.' bfSlash ];
if ~isempty(varargin)
	inDirStr = varargin{1};
	if exist(inDirStr,'dir')
		handles.inDir = inDirStr;
	end
else
	inDirStr = pwd;
	handles.inDir = inDirStr;
end
set( handles.text_inDir, 'String', inDirStr );
handles.inFileName = lfGetInFileNames( handles );

handles.schedMethod = 'ASAP';
handles.dlyMUL = 1;
handles.dlyALU = 1;
handles.nMULs  = 1;
handles.nALUs  = 1;

set( handles.radiobutton_ASAP, 'Value', 1 );
set( handles.edit_dlyMUL, 'String', '1' );
set( handles.edit_dlyALU, 'String', '1' );
set( handles.edit_nMULs,  'String', '1' );
set( handles.edit_nALUs,  'String', '1' );
set( handles.edit_nMULs,  'Visible', 'off' );
set( handles.edit_nALUs,  'Visible', 'off' );
set( handles.text_nMULs,  'Visible', 'off' );
set( handles.text_nALUs,  'Visible', 'off' );

fConfig;
if ~( dotDir(end) == bfSlash )
	dotDir = [ dotDir bfSlash ];
end
handles.dotDirStr = dotDir;
handles.dotValid  = 0;

axes(handles.axes_optSched); cla; uimenu;
h = gca;
handles.h_optSched = h;
hPosition     = get(h,'Position');
hSize = [ hPosition(3)  hPosition(4) ];
handles.hSize    = hSize;
handles.realSize = hSize;
guidata(hObject, handles);


% use a .png file for the logo with a transparant background ...
TUD_logo = 'TUD_bl-zw.png';
set(hObject, 'Units', 'pixels' );
% ... and let this machine's set-up fill in the background
handles.logo1 = imread( TUD_logo,'BackgroundColor', get(hObject,'Color') );
axes(handles.axes_logo);
image(handles.logo1);
set(handles.axes_logo, 'Visible', 'off', 'Units', 'pixels' );

% UIWAIT makes schedGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = schedGUI_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --------------------------------------------------------------------
function subMenu_inDir_Callback(hObject, eventdata, handles)
	fidx = fopen( 'inDir.hist', 'r' );
	if ( fidx ~= -1 )
		inDirStr = fscanf( fidx, '%s' );
		handles.inDir = inDirStr;
		fclose( fidx );
	end
	inDirStr = uigetdir( handles.inDir, 'Select Input Folder' );
	if ( inDirStr ~= 0 )
		handles.inDir = inDirStr;
		handles.inFileName = lfGetInFileNames( handles );
		guidata( hObject, handles );	% store the changes
		% write to hidden file that schedGUI can read at startup
		fidx = fopen('inDir.hist','w');
		fprintf( fidx, '%s\n', inDirStr );
		fclose( fidx );
	end
	set( handles.text_inDir, 'String', inDirStr );


% --------------------------------------------------------------------
function subMenu_refresh_Callback(hObject, eventdata, handles)
	handles.inFileName = lfGetInFileNames( handles );
	guidata( hObject, handles );		% store the changes

% --------------------------------------------------------------------
function submenu_PrintPreview_Callback(hObject, eventdata, handles)
 % NOG: TEST OP GELDIGHEID
	h = handles.h_optSched;
	% create a new figure for saving and printing
	hiddenFig = figure('visible','off');
	% copy axes into the new figure
	newax = copyobj(h,hiddenFig);
	assignin('base','hiddenFig',hiddenFig)
	assignin('base','newax',newax)
	axis image
	xl    = xlim;
	yl    = ylim;
	xSize = xl(2) - xl(1);
	ySize = yl(2) - yl(1);
	set(hiddenFig,'PaperType','A4');
	set(hiddenFig,'PaperUnits','centimeters');
	set(hiddenFig,'Position',[10 50 xSize ySize]);
	set(newax,'Position',[0 0 xSize ySize]);
	set(newax,'Box','off')
	% print and/or save the figure
	printpreview(hiddenFig);
	
	% HOE TERUG, als direct close dan printpreview weg!!!
	%close(hiddenFig) 	% clean up by closing it

% --------------------------------------------------------------------
function subMenu_Exit_Callback(hObject, eventdata, handles)
	lfExitDlg(handles);




% --- Executes during object creation, after setting all properties.
function popupmenu_inFileName_CreateFcn(hObject, eventdata, handles)
	if ispc
    	set(hObject,'BackgroundColor','white');
	else
    	set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
	end

function popupmenu_inFileName_Callback(hObject, eventdata, handles)
	namesList = get(hObject, 'String' );
	handles.inFileName = char( namesList( get(hObject, 'Value') ) );
	handles.dotValid   = 0;
	guidata( hObject, handles );			% store the changes
	


% --- Executes during object creation, after setting all properties.
function edit_dlyMUL_CreateFcn(hObject, eventdata, handles)
	if ispc
    	set(hObject,'BackgroundColor','white');
	else
    	set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
	end

function edit_dlyMUL_Callback(hObject, eventdata, handles)
	prevValue = handles.dlyMUL;
	dlyMUL    = round( str2double( get( hObject, 'String' ) ) );
	if ~( (dlyMUL >= 1) & (dlyMUL <= 15) )
		beep;
		dlyMUL = prevValue;
	end
	handles.dlyMUL   = dlyMUL;
	handles.dotValid = 0;
	guidata( hObject, handles );			% store the changes
	set( hObject, 'String', int2str(dlyMUL) );


% --- Executes during object creation, after setting all properties.
function edit_dlyALU_CreateFcn(hObject, eventdata, handles)
	if ispc
    	set(hObject,'BackgroundColor','white');
	else
    	set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
	end

function edit_dlyALU_Callback(hObject, eventdata, handles)
	prevValue = handles.dlyALU;
	dlyALU    = round( str2double( get( hObject, 'String' ) ) );
	if ~( (dlyALU >= 1) & (dlyALU <= 15) )
		beep;
		dlyALU = prevValue;
	end
	handles.dlyALU   = dlyALU;
	handles.dotValid = 0;
	guidata( hObject, handles );			% store the changes
	set( hObject, 'String', int2str(dlyALU) );


% --- Executes during object creation, after setting all properties.
function edit_nMULs_CreateFcn(hObject, eventdata, handles)
	if ispc
    	set(hObject,'BackgroundColor','white');
	else
    	set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
	end

function edit_nMULs_Callback(hObject, eventdata, handles)
	prevValue = handles.nMULs;
	nMULs    = round( str2double( get( hObject, 'String' ) ) );
	if ~( (nMULs >= 1) & (nMULs <= 15) )
		beep;
		nMULs = prevValue;
	end
	handles.nMULs    = nMULs;
	handles.dotValid = 0;
	guidata( hObject, handles );			% store the changes
	set( hObject, 'String', int2str(nMULs) );


% --- Executes during object creation, after setting all properties.
function edit_nALUs_CreateFcn(hObject, eventdata, handles)
	if ispc
    	set(hObject,'BackgroundColor','white');
	else
    	set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
	end

function edit_nALUs_Callback(hObject, eventdata, handles)
	prevValue = handles.nALUs;
	nALUs    = round( str2double( get( hObject, 'String' ) ) );
	if ~( (nALUs >= 1) & (nALUs <= 15) )
		beep;
		nALUs = prevValue;
	end
	handles.nALUs    = nALUs;
	handles.dotValid = 0;
	guidata( hObject, handles );			% store the changes
	set( hObject, 'String', int2str(nALUs) );




function radiobutton_ASAP_Callback(hObject, eventdata, handles)
	% don't switch off by pushing own button
	if ( get( handles.radiobutton_ASAP, 'Value' ) == 0 )
		set( handles.radiobutton_ASAP,  'Value', 1 );
	else
		off = [ handles.radiobutton_ALAP, handles.radiobutton_ForceD, ...
													handles.radiobutton_LIST ];
		lfMutualExclude( off );
		handles.schedMethod = 'ASAP';
		set( handles.edit_nMULs, 'Visible', 'off' );
		set( handles.edit_nALUs, 'Visible', 'off' );
		set( handles.text_nMULs, 'Visible', 'off' );
		set( handles.text_nALUs, 'Visible', 'off' );
		handles.dotValid = 0;
	end
	guidata( hObject, handles );			% store the changes


function radiobutton_ALAP_Callback(hObject, eventdata, handles)
	% don't switch off by pushing own button
	if ( get( handles.radiobutton_ALAP, 'Value' ) == 0 )
		set( handles.radiobutton_ALAP,  'Value', 1 );
	else
		off = [ handles.radiobutton_ASAP, handles.radiobutton_ForceD, ...
													handles.radiobutton_LIST ];
		lfMutualExclude( off );
		handles.schedMethod = 'ALAP';
		set( handles.edit_nMULs, 'Visible', 'off' );
		set( handles.edit_nALUs, 'Visible', 'off' );
		set( handles.text_nMULs, 'Visible', 'off' );
		set( handles.text_nALUs, 'Visible', 'off' );
		handles.dotValid = 0;
	end
	guidata( hObject, handles );			% store the changes


function radiobutton_ForceD_Callback(hObject, eventdata, handles)
	% don't switch off by pushing own button
	if ( get( handles.radiobutton_ForceD, 'Value' ) == 0 )
		set( handles.radiobutton_ForceD,  'Value', 1 );
	else
		off = [ handles.radiobutton_ASAP, handles.radiobutton_ALAP, ...
													handles.radiobutton_LIST ];
		lfMutualExclude( off );
		handles.schedMethod = 'ForceD';
		set( handles.edit_nMULs, 'Visible', 'off' );
		set( handles.edit_nALUs, 'Visible', 'off' );
		set( handles.text_nMULs, 'Visible', 'off' );
		set( handles.text_nALUs, 'Visible', 'off' );
		handles.dotValid = 0;
	end
	guidata( hObject, handles );			% store the changes


function radiobutton_LIST_Callback(hObject, eventdata, handles)
	% don't switch off by pushing own button
	if ( get( handles.radiobutton_LIST, 'Value' ) == 0 )
		set( handles.radiobutton_LIST,  'Value', 1 );
	else
		off = [ handles.radiobutton_ASAP, handles.radiobutton_ALAP, ...
													handles.radiobutton_ForceD ];
		lfMutualExclude( off );
		handles.schedMethod = 'LIST';
		set( handles.edit_nMULs, 'Visible', 'on' );
		set( handles.edit_nALUs, 'Visible', 'on' );
		set( handles.text_nMULs, 'Visible', 'on' );
		set( handles.text_nALUs, 'Visible', 'on' );
		handles.dotValid = 0;
	end
	guidata( hObject, handles );			% store the changes



% --- Executes on button press in pushbutton_Preview.
%******************************************************************************************
function pushbutton_Preview_Callback(hObject, eventdata, handles)

	plot_distrib_MUL = handles.axes_distrib_MUL;
	plot_distrib_ALU = handles.axes_distrib_ALU;
	axes(plot_distrib_MUL);			cla;  
	axes(plot_distrib_ALU);			cla;
	axes(handles.axes_optSched);	cla; uimenu;
	h = handles.h_optSched;

	if ~isempty(handles.inFileName)
		[T,distrib,result,iconnTbl,opTypes,handles] = lfSchedule(hObject,handles);
		assignin( 'base', 'T', T );
		assignin( 'base', 'distrib', distrib );
		nStates = size(distrib,1);
		if ( result ~= 0 )
			% here graph.dot has been written
			eval( [ '!' handles.dotDirStr 'dot graph.dot -T hpgl -o tmp.hpg -q2' ]);
			textHandles = hpgPlot('tmp.hpg',handles.hSize);
			delete ('tmp.hpg');
			handles.dotValid = 1;
			set( handles.text_schedMethod, 'String', handles.schedMethod );
			% enable pan and zoom facilities
			axdrag2('initialize', h,textHandles);

			[MUL2OpTbl,ALU2OpTbl,altMULs,altALUs,op2RscTbl] = ...
										mapResources(T,distrib,iconnTbl(:,:,1),opTypes);
			neededRegs = lifeTimes(iconnTbl(:,:,1),T,[MUL2OpTbl ALU2OpTbl]);
			set( handles.text_totalRegs, 'String', num2str( size(neededRegs,2) ) );

			%----
			axes(plot_distrib_MUL);
			barh(flipud(distrib(:,1))); 
			axis([ 0 max(max(distrib(:,1))+1,3)  0 nStates+1 ] );
			labels = get(plot_distrib_MUL,'YTickLabel');
			% although MLint may suggest otherwise, use 'str2num' here:
			newLabels = num2str( nStates+1 - str2num(labels) );
			set(plot_distrib_MUL,'YTickLabel',newLabels);
			set(plot_distrib_MUL,'FontSize',8);
			set(plot_distrib_MUL,'XGrid','on');
			set(plot_distrib_MUL,'YGrid','on');
			%----
			axes(plot_distrib_ALU);
			barh(flipud(distrib(:,2))); 
			axis([ 0 max(max(distrib(:,2))+1,3)  0 nStates+1 ] );
			set(plot_distrib_ALU,'YTickLabel',newLabels);
			set(plot_distrib_ALU,'FontSize',8);
			set(plot_distrib_ALU,'XGrid','on');
			set(plot_distrib_ALU,'YGrid','on');

%{
	showRegs(	handles.inFileName, ...
				handles.schedMethod, ...
				handles.dlyMUL, ...
				handles.dlyALU, ...
				handles.nMULs, ...
				handles.nALUs );
%}

		else
			handles.dotValid = 0;
		end
		guidata( hObject, handles );		% store the changes
	else
		errordlg( 'No input file specified ...', 'File Error' );
		beep;
	end

%******************************************************************************************


% --- Executes on button press in pushbutton_writeOutput.
function pushbutton_writeOutput_Callback(hObject, eventdata, handles)
	if ~isempty(handles.inFileName)
		doDot = 1;
		if ~handles.dotValid
			% Get the current position of the GUI from the handles structure
			pos_size = get(handles.figure1, 'Position' );
			beep;
			messageStr  = { 'Parameter settings don''t match Preview plots !'; ...
							'Really Write using the Parameters ?' };
			userResponse = questdlg( messageStr, 'Mismatch Warning', ...
															'Yes','No', 'No' );
			if strcmp( userResponse,'Yes' )
				lfSchedule( handles );
			else
				doDot = 0;
			end
		end
		if doDot
			chooseExt = { 'png'; 'jpg'; 'ps' };
			[fileName, pathName, filterIx] = uiputfile( ...
								{ '*.png', 'Portable Network Graphics (*.png)'; ...
								  '*.jpg', 'JPG-JPEG Compliant (*.jpg)'; ...
								  '*.ps',  'Postscript (*.ps)' }, ...
								  'Save Graph as' );
			if ( filterIx ~= 0 )
				outExt = char( chooseExt{filterIx} );
				fConfig;
				fullFileName = fullfile(pathName,fileName);
				dotDirStr = handles.dotDirStr;
				eval( [ '!' dotDirStr 'dot graph.dot -T ' outExt ' -o ' fullFileName ] );
			end
			beep;
		end
	else
		errordlg( 'No input file specified ...', 'File Error' );
		beep;
	end
	

% --- Executes on button press in pushbutton_Quit.
function pushbutton_Quit_Callback(hObject, eventdata, handles)
	lfExitDlg(handles);



%==========================================================================================
%=========  LOCAL FUNCTIONS  ======  LOCAL FUNCTIONS  ======  LOCAL FUNCTIONS  ============
%==========================================================================================

function inFileName = lfGetInFileNames( handles )
%	inFiles    = dir( [ handles.inDir '\in_*.m' ] );
	inFiles    = dir( [ handles.inDir '/*.cir' ] );
	if ~isempty(inFiles)
		inFileName = inFiles(1).name;
		nameStr = {inFileName};
		for i = 2:size(inFiles,1)
			nameStr = [ nameStr; {inFiles(i).name} ];
		end
	else
		inFileName = '';
		nameStr    = '   --- no input file(s) ---   ';
	end
	set(handles.popupmenu_inFileName, 'String', nameStr );

% --------------------------------------------------------------------
function lfMutualExclude( off )
  set(off, 'Value',0);

% --------------------------------------------------------------------
function lfMutualUncheck( on,off )
  set(on , 'Checked','on' );
  set(off, 'Checked','off');

% --------------------------------------------------------------------
function [T,distrib,result,iconnTbl,opTypes,handles] = lfSchedule(hObject,handles)
	schedMethod = lower(handles.schedMethod);
	dlyMUL 		= handles.dlyMUL;
	dlyALU 		= handles.dlyALU;
	if ( strcmp(schedMethod,'forced') && ~((dlyMUL==1) && (dlyALU==1)) )
		beep;
		errordlg( 'ForceD doesn''t yet handle arbitrary delays ...', 'NYI Error', 'modal' );
		handles.dlyMUL = 1;
		handles.dlyALU = 1;
		set( handles.edit_dlyMUL, 'String', '1' );
		set( handles.edit_dlyALU, 'String', '1' );
		T        = [];
		distrib  = [];
		result   = 0;
		iconnTbl = [];
	else
		inFileName = [ handles.inDir filesep handles.inFileName ];
		% read input data
		CIRC_Data = parse( inFileName );
		iconnTbl  = CIRC_Data.iconnTbl;		% from June 2005, with shift info (:,:,2)
		opTypes   = CIRC_Data.opTypes;
		
		SSG_Data.inFilename = inFileName;
		SSG_Data.method     = schedMethod;
		SSG_Data.delayMUL   = dlyMUL;
		SSG_Data.delayALU   = dlyALU;
		SSG_Data.nMULs      = handles.nMULs;
		SSG_Data.nALUs      = handles.nALUs;
		SSG_Data.dateStr    = datestr(now);
		
		[T,distrib] = schedule(CIRC_Data, SSG_Data);
		result = 1;
    end
	guidata( hObject, handles );		% store the changes

% --------------------------------------------------------------------
function lfExitDlg(handles)
	% Get the current position of the GUI from the handles structure
	% to pass to the modal dialog.
	beep;
	userResponse = questdlg( 'Do you really want to quit ?', 'Confirm Quit', ...
														'Yes','No', 'Yes' );
	if strcmp( userResponse,'Yes' )
		delete(handles.figure1);
	end




% --------------------------------------------------------------------
function menu_File_Callback(hObject, eventdata, handles)
% hObject    handle to menu_Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function subMenu_outFormat_Callback(hObject, eventdata, handles)
% hObject    handle to subMenu_outFormat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function menu_Edit_Callback(hObject, eventdata, handles)
% hObject    handle to menu_Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function menu_Help_Callback(hObject, eventdata, handles)
% hObject    handle to menu_Help (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function subMenu_previewHelp_Callback(hObject, eventdata, handles)
helpStr = { 'Viewing of the plot can be improved by using'
            'the following pan and zoom options.'
            '(First select the Window by clicking on it'
            '         and keeping the mouse in its area.)'
            ' '
            'Keys:'
            '  + : Zoom In'
            '  - : Zoom Out'
            '  * : Reset to Original View'
            ' '
            'Arrow keys:' 
            '  Pan over Figure'
            ' '
            'Mouse with any button pressed:' 
            '  Move Figure'
            '  NOTE: position the mouse BETWEEN objects,'
            '        NOT ON an object while moving ....'
          };
helpwin(helpStr,'PreviewPane Options ...');
  
% --------------------------------------------------------------------
function subMenu_About_Callback(hObject, eventdata, handles)
	aboutStr = { '     (C) Huibert J. Lincklaen Arrins', ...
	             '', ...
	             '      Delft University of Technology', ...
	             '                                 2004 / 2005'};
	iconData = reshape( repmat(imread('about.gif'),1,3), 64,64,3 );
	uiwait(msgbox(aboutStr,'About ...','custom',iconData,'default','modal'));



% --- Executes on mouse press over figure background.
function figure1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)





% --- Executes on button press in pushbutton_View_Cir_IO.
function pushbutton_View_Cir_IO_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_View_Cir_IO (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton_gen_matlabTB.
function pushbutton_gen_matlabTB_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_gen_matlabTB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton_gen_VHD.
function pushbutton_gen_VHD_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_gen_VHD (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




