function showDistrib(cirFilename,schedMethod,varargin)


     
bfSlash = filesep;
fName   = strtok(cirFilename, '.');

% read input data
CIRC_Data = parse(cirFilename);
%InOuts = groupIOs(CIRC_Data);

schedMethod = lower(schedMethod);
if isempty(varargin)
	delayMUL = 1;
	delayALU = 1;
else
	delayMUL = varargin{1};
	delayALU = varargin{2};
end
if strcmp(schedMethod,'list')
	if ( size(varargin,2) <= 2 )
		nMULs = 1;
		nALUs = 1;
		fprintf( 'LIST: 1 multiplier and 1 ALU assumed ...\n' );
	elseif ( size(varargin,2) == 4 )
		nMULs = varargin{3};
		nALUs = varargin{4};
	else
		error( 'LIST ERROR: Specify number of multipliers AND number of ALU''s ...' );
	end
else
	nMULs = 1;
	nALUs = 1;
end

dateStr = datestr(clock);
% for easy passing to function calls, collect in one structure
SSG_Data.filePath   = [ pwd bfSlash cirFilename ];
SSG_Data.inFilename = fName;
SSG_Data.method     = schedMethod;
SSG_Data.delayMUL   = delayMUL;
SSG_Data.delayALU   = delayALU;
SSG_Data.nMULs      = nMULs;
SSG_Data.nALUs      = nALUs;
SSG_Data.dateStr    = dateStr;

[T,distrib] = schedule(CIRC_Data,SSG_Data);
nStates     = max( max(T) );
maxMULs	    = max( distrib(:,1) );
maxALUs	    = max( distrib(:,2) );

figure(2)
set(gcf,'NumberTitle','off', 'Name',[ ' Resource Distribution for  "' cirFilename(1:end-4) '"' ] );
set(gcf,'ToolBar','none');
set(gcf,'MenuBar','none');

clf
if ( nStates > 20 )
	hState = 30;
	topY   = -1.5;
else
	hState = 36;
	topY   = -1;
end
yHeight = (nStates+2) * hState;
set(gcf,'Position', [ 40 965-yHeight  (12+2)*65 yHeight ] ); 
line(0.1,1);
hold on
lineCol = [ 0.9  0.9  0.9;
			1.0  0.8  0.8;
			0.8  1.0  1.0;
			0.8  1.0  0.8;
			1.0  1.0  0.8;
			1.0  0.8  1.0;
			0.8  0.8  1.0 ];					
for i = 1:nStates
	plot( [-0.5 +0.5],[i i], 'k:' );
end






h_subp1 = subplot(1,2, 1);
h_bar = barh( distrib(:,1) ); 
axis( [ 0 max(maxMULs+1,3)  0 nStates+1 ] );
set( h_subp1, 'YDir','reverse'  );
set( h_subp1, 'FontSize',9 );
set( h_subp1, 'XGrid','on' );
set( h_subp1, 'YGrid','on' );
set( h_subp1, 'Box','off' );
set( h_bar, 'FaceColor',[0.3  0.2  0.3] );
title( 'number of MULTIPLIERs' );
ylabel( 'STATEnumber' );

get( h_subp1, 'Position' );

%----
h_subp2 = subplot(1,2, 2);
barh( distrib(:,2) ); 
axis( [ 0 max(maxALUs+1,3)  0 nStates+1 ] );
set( h_subp2, 'YDir','reverse'  );
set( h_subp2, 'FontSize',9 );
set( h_subp2, 'XGrid','on' );
set( h_subp2, 'YGrid','on' );
set( h_subp2, 'Box','off' );
title( 'number of ALUs' );
ylabel( 'STATEnumber' );

get( h_subp2, 'Position' );
