function showGraph(gFormat)
%SHOWGRAPH	Converts 'graph.dot' to an image and opens a viewer to show it.
%	SHOWGRAPH(gFormat) displays the image described in 'graph.dot'
%	using the intermediate file 'graph.xxx', where 'xxx' is replaced
%	by the string given in 'gFormat'.
%	Valid formats are 'png', 'jpg', 'hpg' ...
%
%	See also  VIEW_CIR_IO.

% (c) H.J. Lincklaen Arriens, 
%     Delft University of Technology, November 2004


cmdStr = sprintf( '-T %s -o graph.%s', gFormat, gFormat ); 
fConfig;
if ~( dotDir(end) == filesep )
	dotDir = [ dotDir filesep ];
end
eval( [ '!' dotDir 'dot graph.dot ' cmdStr ] );
% start imageviewer and let it return
if ispc
	platform = system_dependent('getos');
	if strcmp(platform(end-1:end),'XP')
		system( 'rundll32 c:\windows\system32\shimgvw.dll ImageView_Fullscreen &' );
		% then show image file
		eval( [ '!graph.' gFormat ] );
	else
		system( [ 'explorer graph.' gFormat ] );
	end
else
    system( 'xv graph_io.png &' );
end
