function showRegs(neededRegs,nStates,opNames,SSG_Data)

%SSG_Data.filePath   = [ pwd bfSlash cirFilename ];
fName       = SSG_Data.inFilename;
schedMethod = SSG_Data.method;
delayMUL    = SSG_Data.delayMUL;
delayALU    = SSG_Data.delayALU;
nMULs       = SSG_Data.nMULs;
nALUs       = SSG_Data.nALUs;
dateStr     = SSG_Data.dateStr;

     
nRegs	   = size(neededRegs,2);

figure(1)
clf
if ( nStates > 20 )
	hState = 36;
	topY   = -1.5;
else
	hState = 50;
	topY   = -1;
end
yHeight = (nStates+2) * hState;
set(gcf,'Position', [ 40 965-yHeight  (nRegs+2)*65 yHeight ] ); 
line(-1,-1);
hold on
lineCol = [ 0.9  0.9  0.9;
			1.0  0.8  0.8;
			0.8  1.0  1.0;
			0.8  1.0  0.8;
			1.0  1.0  0.8;
			1.0  0.8  1.0;
			0.8  0.8  1.0 ];					
% horizontal grid line(s)
for i = 1:nStates
	plot( [-0.5 nRegs+0.5],[i i], 'k:' );
end
for i = 1:nRegs
	colIx     = 1;
	thisState = 1;
	% vertical grid line(s)
	plot( [i i],[0.5 nStates+1.5], 'k:' );
	text( i-0.2,0, [ 'R\_' int2str(i) ], 'FontSize',9 );
	while (  thisState < nStates+1 )
		opNo = neededRegs(thisState,i);
		if ( opNo ~= 0 )
			opNoStates  = find( neededRegs(:,i) == opNo );
			nextOpState = opNoStates(end) +1;
			lfDrawColBox( i,opNoStates(1), i,nextOpState, lineCol( mod(colIx-1,6)+1,: ) );
			text( i-0.27,opNoStates(1)+0.35, opNames{opNo}, 'FontSize',9 );
			thisState = nextOpState;
			colIx     = colIx +1;
		else
			thisState = thisState +1;
		end
	end
end
axis( [ -1.5 nRegs+1  -1 nStates+1 ] );
for i = 2:nStates
	text( -1.0, i-0.5, [ 'STATE ' num2str(i) ], 'FontSize',9 );
end
if strcmp(schedMethod,'list') 
    infoStr = sprintf( '%s,  %d, %d,  %d, %d', upper(schedMethod), delayMUL, delayALU, ...
														             	    nMULs, nALUs );
else
    infoStr = sprintf( '%s,  %d, %d', upper(schedMethod), delayMUL, delayALU );
end
topX = text( -1,topY, infoStr, 'FontSize',9 );
	
hold off
set(gca, 'YDir','reverse'  )
axis off
% use the next COMBINATION
%axis equal;
axis image; axis normal
%{ or:
set(gca, 'xTickLabel','' )
set(gca, 'xTick',[] )
set(gca, 'yTickLabel','' )
set(gca, 'yTick',[] )
set(gca, 'Box','on' )
%}
set(gcf,'NumberTitle','off', 'Name',[ ' Register binding for  "' fName '"' ] );
set(gcf,'MenuBar','none');


%==========================================================================================
%=========  LOCAL FUNCTIONS  ======  LOCAL FUNCTIONS  ======  LOCAL FUNCTIONS  ============
%==========================================================================================
function lfDrawColBox( x1,y1, x2,y2, col )
  dx = 0.4;
  x1 = x1 - dx;
  x2 = x2 + dx; 
  patch( [x1 x2 x2 x1 x1], [y1 y1 y2 y2 y1], col );